%make plots for the TBI block for the piecewise linear bistable function

set(0,                           ...
   'defaultaxesfontsize', 20,   ...
   'defaultaxeslinewidth', 1.0, ...
   'defaultlinelinewidth', 1.2, ...
   'defaultpatchlinewidth', 0.7); %specify alpha

alplist = [0.15,0.25,0.4];

for j = 1:3
    
alp = alplist(j);
Alim = ((1-alp)/alp)^2;

Ar = [Alim+.0001:0.1:100];
sqAr = sqrt(Ar);

f=(sqAr-1).*(alp*sqAr/(1-alp)+1)./((sqAr+1).*(alp*sqAr/(1-alp)-1));
Y = log(f).*sqAr/2;

plot(Y,Ar,'linewidth',2)
hold on
end
axis([0 15 0 100])
xlabel('Y','fontsize',20)
ylabel('A_r','fontsize',20)
text(10,40,'\alpha = 0.1','fontsize',20)
text(5,14,'\alpha = 0.25','fontsize',20)

text(1.5,6,'\alpha = 0.4','fontsize',20)


hold off

